-- Universal 1010 DT
-- Script Specializare Pentru UTB 1010 DT
--
-- Script BY Mihai94
--
-- A nu  Se Edita Fara Permisiunea Mea


UTB1010DT = {};

function UTB1010DT.prerequisitesPresent(specializations)
   return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function UTB1010DT:load(xmlFile)

      self.UTB1010DTAjutor = false;
      self.isSelectable = true
      self.rotationDirection = true;
      self.engineRunTime = 0;
	  self.cycleRoundMax = 30;
	  self.currentCycle = 0;
	  self.lastRpm = 0;
	  self.Ventilator = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Ventilator#index"));
      self.VentilatorAlternator = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.VentilatorAlternator#index"));
      self.Rola = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Rola#index"));
      self.Rola1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Rola1#index"));
	  self.TimpCalareRadiator = 0;
      self.TimpGripareMotor = 0;
	  
    local rotationNodeUsaStanga = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.UsaStanga#index"));
    if rotationNodeUsaStanga ~= nil then
        self.rotationUsaStanga = {};
        self.rotationUsaStanga.node = rotationNodeUsaStanga;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UsaStanga#minRot"));
        self.rotationUsaStanga.minRot = {};
        self.rotationUsaStanga.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationUsaStanga.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationUsaStanga.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UsaStanga#maxRot"));
        self.rotationUsaStanga.maxRot = {};
        self.rotationUsaStanga.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationUsaStanga.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationUsaStanga.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationUsaStanga.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UsaStanga#rotTime"), 2)*1000;
        self.rotationUsaStanga.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.UsaStanga#touchRotLimit"), 10));
    end;


    local rotationNodeUsaDreapta = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.UsaDreapta#index"));
    if rotationNodeUsaDreapta ~= nil then
        self.rotationUsaDreapta = {};
        self.rotationUsaDreapta.node = rotationNodeUsaDreapta;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UsaDreapta#minRot"));
        self.rotationUsaDreapta.minRot = {};
        self.rotationUsaDreapta.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationUsaDreapta.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationUsaDreapta.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UsaDreapta#maxRot"));
        self.rotationUsaDreapta.maxRot = {};
        self.rotationUsaDreapta.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationUsaDreapta.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationUsaDreapta.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationUsaDreapta.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UsaDreapta#rotTime"), 2)*1000;
        self.rotationUsaDreapta.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.UsaDreapta#touchRotLimit"), 10));
    end;


    local GeamSpateNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.GeamSpate#index"));
    if GeamSpateNode ~= nil then
        self.GeamSpate = {};
        self.GeamSpate.node = GeamSpateNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.GeamSpate#minRot"));
        self.GeamSpate.minRot = {};
        self.GeamSpate.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.GeamSpate.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.GeamSpate.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.GeamSpate#maxRot"));
        self.GeamSpate.maxRot = {};
        self.GeamSpate.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.GeamSpate.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.GeamSpate.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.GeamSpate.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.GeamSpate#rotTime"), 200);
        self.GeamSpate.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.GeamSpate#touchRotLimit"), 10));
    end;

    local rotationNodeCupla = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Cupla#index"));
    if rotationNodeCupla ~= nil then
        self.rotationCupla = {};
        self.rotationCupla.node = rotationNodeCupla;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Cupla#minRot"));
        self.rotationCupla.minRot = {};
        self.rotationCupla.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationCupla.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationCupla.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Cupla#maxRot"));
        self.rotationCupla.maxRot = {};
        self.rotationCupla.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationCupla.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationCupla.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationCupla.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Cupla#rotTime"), 2)*1000;
        self.rotationCupla.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.Cupla#touchRotLimit"), 10));
    end;


      local rotationNodeCapota = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Capota#index"));
    if rotationNodeCapota ~= nil then
        self.rotationCapota = {};
        self.rotationCapota.node = rotationNodeCapota;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Capota#minRot"));
        self.rotationCapota.minRot = {};
        self.rotationCapota.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationCapota.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationCapota.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Capota#maxRot"));
        self.rotationCapota.maxRot = {};
        self.rotationCapota.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationCapota.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationCapota.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationCapota.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Capota#rotTime"), 2)*1000;
        self.rotationCapota.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.Capota#touchRotLimit"), 10));
    end;

     local rotationPartNodebujanie = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.TrepidatiiMotor#index"));
   	if rotationPartNodebujanie ~= nil then
        self.rotationPartbujanie = {};
        self.rotationPartbujanie.node = rotationPartNodebujanie;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.TrepidatiiMotor#minRot"));
        self.rotationPartbujanie.minRot = {};
        self.rotationPartbujanie.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbujanie.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbujanie.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.TrepidatiiMotor#maxRot"));
        self.rotationPartbujanie.maxRot = {};
        self.rotationPartbujanie.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbujanie.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbujanie.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartbujanie.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.TrepidatiiMotor#rotTime"), 2)*1000;
        self.rotationPartbujanie.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.TrepidatiiMotor#touchRotLimit"), 10));
    end;
		self.bujaj = 80;

	local rotationPartNodeCarburant = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartCarburant#index"));
    if rotationPartNodeCarburant ~= nil then
        self.rotationPartCarburant = {};
        self.rotationPartCarburant.node = rotationPartNodeCarburant;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartCarburant#minRot"));
        self.rotationPartCarburant.minRot = {};
        self.rotationPartCarburant.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartCarburant.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartCarburant.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartCarburant#maxRot"));
        self.rotationPartCarburant.maxRot = {};
        self.rotationPartCarburant.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartCarburant.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartCarburant.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartCarburant.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartCarburant#rotTime"), 50);
        self.rotationPartCarburant.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartCarburant#touchRotLimit"), 10));
    end;
	
	local rotationPartNodePresiuneUlei = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#index"));
    if rotationPartNodePresiuneUlei ~= nil then
        self.rotationPartPresiuneUlei = {};
        self.rotationPartPresiuneUlei.node = rotationPartNodePresiuneUlei;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#minRot"));
        self.rotationPartPresiuneUlei.minRot = {};
        self.rotationPartPresiuneUlei.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPresiuneUlei.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPresiuneUlei.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#maxRot"));
        self.rotationPartPresiuneUlei.maxRot = {};
        self.rotationPartPresiuneUlei.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPresiuneUlei.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPresiuneUlei.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartPresiuneUlei.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#rotTime"), 50);
        self.rotationPartPresiuneUlei.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeTemperaturaApa = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#index"));
    if rotationPartNodeTemperaturaApa ~= nil then
        self.rotationPartTemperaturaApa = {};
        self.rotationPartTemperaturaApa.node = rotationPartNodeTemperaturaApa;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#minRot"));
        self.rotationPartTemperaturaApa.minRot = {};
        self.rotationPartTemperaturaApa.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTemperaturaApa.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTemperaturaApa.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#maxRot"));
        self.rotationPartTemperaturaApa.maxRot = {};
        self.rotationPartTemperaturaApa.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTemperaturaApa.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTemperaturaApa.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        
        self.rotationPartTemperaturaApa.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#rotTime"), 200);
        self.rotationPartTemperaturaApa.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#touchRotLimit"), 10));
    end;
    
  	local rotationPartNodeTurometru = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartTurometru#index"));
    if rotationPartNodeTurometru ~= nil then
        self.rotationPartTurometru = {};
        self.rotationPartTurometru.node = rotationPartNodeTurometru;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTurometru#minRot"));
        self.rotationPartTurometru.minRot = {};
        self.rotationPartTurometru.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTurometru.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTurometru.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTurometru#maxRot"));
        self.rotationPartTurometru.maxRot = {};
        self.rotationPartTurometru.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTurometru.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTurometru.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        
        self.rotationPartTurometru.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTurometru#rotTime"), 2)*1000;
        self.rotationPartTurometru.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTurometru#touchRotLimit"), 10));
    end;

    local rotationPartNodewajcha5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ManetaSemnalizareS#index"));
   if rotationPartNodewajcha5 ~= nil then
       self.rotationPartwajcha5 = {};
       self.rotationPartwajcha5.node = rotationPartNodewajcha5;

       local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaSemnalizareS#minRot"));
       self.rotationPartwajcha5.minRot = {};
       self.rotationPartwajcha5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaSemnalizareS#maxRot"));
       self.rotationPartwajcha5.maxRot = {};
       self.rotationPartwajcha5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       self.rotationPartwajcha5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaSemnalizareS#rotTime"), 2)*1000;
       self.rotationPartwajcha5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaSemnalizareS#touchRotLimit"), 10));
   end;

    local rotationPartNodewajcha6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ManetaAvarii#index"));
   if rotationPartNodewajcha6 ~= nil then
       self.rotationPartwajcha6 = {};
       self.rotationPartwajcha6.node = rotationPartNodewajcha6;

       local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaAvarii#minRot"));
       self.rotationPartwajcha6.minRot = {};
       self.rotationPartwajcha6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaAvarii#maxRot"));
       self.rotationPartwajcha6.maxRot = {};
       self.rotationPartwajcha6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       self.rotationPartwajcha6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaAvarii#rotTime"), 2)*1000;
       self.rotationPartwajcha6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaAvarii#touchRotLimit"), 10));
   end;

    local rotationPartNodewajcha7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ManetaSemnalizareD#index"));
   if rotationPartNodewajcha7 ~= nil then
       self.rotationPartwajcha7 = {};
       self.rotationPartwajcha7.node = rotationPartNodewajcha7;

       local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaSemnalizareD#minRot"));
       self.rotationPartwajcha7.minRot = {};
       self.rotationPartwajcha7.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha7.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha7.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaSemnalizareD#maxRot"));
       self.rotationPartwajcha7.maxRot = {};
       self.rotationPartwajcha7.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha7.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha7.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       self.rotationPartwajcha7.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaSemnalizareD#rotTime"), 2)*1000;
       self.rotationPartwajcha7.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaSemnalizareD#touchRotLimit"), 10));
   end;

    local rotationPartNodewajcha8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ManetaPlug#index"));
   if rotationPartNodewajcha8 ~= nil then
       self.rotationPartwajcha8 = {};
       self.rotationPartwajcha8.node = rotationPartNodewajcha8;

       local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaPlug#minRot"));
       self.rotationPartwajcha8.minRot = {};
       self.rotationPartwajcha8.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha8.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha8.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaPlug#maxRot"));
       self.rotationPartwajcha8.maxRot = {};
       self.rotationPartwajcha8.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha8.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha8.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       self.rotationPartwajcha8.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaPlug#rotTime"), 2)*1000;
       self.rotationPartwajcha8.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaPlug#touchRotLimit"), 10));
   end;

 local rotationPartNodewajcha9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ManetaCuplare4X4#index"));
   if rotationPartNodewajcha9 ~= nil then
       self.rotationPartwajcha9 = {};
       self.rotationPartwajcha9.node = rotationPartNodewajcha9;

       local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaCuplare4X4#minRot"));
       self.rotationPartwajcha9.minRot = {};
       self.rotationPartwajcha9.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha9.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha9.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ManetaCuplare4X4#maxRot"));
       self.rotationPartwajcha9.maxRot = {};
       self.rotationPartwajcha9.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartwajcha9.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartwajcha9.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       self.rotationPartwajcha9.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaCuplare4X4#rotTime"), 2)*1000;
       self.rotationPartwajcha9.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.ManetaCuplare4X4#touchRotLimit"), 10));
   end;

     local rotationPartNodeCheieContact = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.CheieContact#index"));
   if rotationPartNodeCheieContact ~= nil then
       self.rotationPartCheieContact = {};
       self.rotationPartCheieContact.node = rotationPartNodeCheieContact;

       local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.CheieContact#minRot"));
       self.rotationPartCheieContact.minRot = {};
       self.rotationPartCheieContact.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartCheieContact.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartCheieContact.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.CheieContact#maxRot"));
       self.rotationPartCheieContact.maxRot = {};
       self.rotationPartCheieContact.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
       self.rotationPartCheieContact.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
       self.rotationPartCheieContact.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

       self.rotationPartCheieContact.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.CheieContact#rotTime"), 2)*1000;
       self.rotationPartCheieContact.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.CheieContact#touchRotLimit"), 10));
   end;

     self.batteriaicona = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.batteriaicona#index")); 
	self.olioicona = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.olioicona#index")); 
     self.olioicona2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.olioicona2#index")); 

     self.frontAxle = {};
	self.frontAxle.rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#rotNode"));
	self.frontAxle.steeringHydraulicsLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringHydraulicsLeft"));
	self.frontAxle.steeringHydraulicsRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringHydraulicsRight"));
	self.frontAxle.steeringPushLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushLeft"));
	self.frontAxle.steeringPushRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushRight"));
	self.frontAxle.steeringPushLeftAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushLeftAttach"));
	self.frontAxle.steeringPushRightAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushRightAttach"));
	self.frontAxle.guidanceRod = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#guidanceRod"));
	
	self.numAnimatedWheels = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.animatedWheels#count"), 0);
	self.animatedWheel = {};
    for i=1, self.numAnimatedWheels do
        local objname = string.format("vehicle.animatedWheels.wheel" .. "%d", i);
		self.animatedWheel[i] = {};
        self.animatedWheel[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		self.animatedWheel[i].wheel = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#wheelIndex"));
		self.animatedWheel[i].fenderAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#fenderAttach"));
    end;

   self.sv2 = {}; -- ich packe meine Variablen in jeder LUA erst mal in einen Table, da es mittlerweile so viele Scripts gibt dass es sonst gern zu berschneidungen kommt.
	-- Indexe der FenderTransforms die spter rotiert werden
	self.sv2.fenderLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Radsturz.Links#index"));
	self.sv2.fenderRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Radsturz.Rechts#index"));
	-- funktioniert auch mit den XML Angaben der lteren LUA
	if self.sv2.fenderLeft == nil then
		self.sv2.fenderLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Fenders.FenderLK#index"));
	end;
	if self.sv2.fenderRight == nil then
		self.sv2.fenderRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Fenders.FenderRK#index"));
	end;
	
	-- Werte die fr die Berechnung notwendig sind. Optionale Angabe in der XML, ansonsten standartwerde.
	self.sv2.berDiv = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.Radsturz#multiplicator"), 45);
	self.sv2.leftRightDifference = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.Radsturz#linksRechtsDifferenz"), 0.8);


    OpenDoorLifeSoundFile = Utils.getFilename("Sunete/UsaStangaDeschisa.wav", self.baseDirectory);
    self.OpenDoorLifeSoundId = createSample("OpenDoorLife");
    loadSample(self.OpenDoorLifeSoundId, OpenDoorLifeSoundFile, false);
    self.OpenDoorLifePlaying = false;

    OpenDoorRightSoundFile = Utils.getFilename("Sunete/UsaDreaptaDeschisa.wav", self.baseDirectory);
    self.OpenDoorRightSoundId = createSample("OpenDoorRight");
    loadSample(self.OpenDoorRightSoundId, OpenDoorRightSoundFile, false);
    self.OpenDoorRightPlaying = false;

    OpenDoorStreesSoundFile = Utils.getFilename("Sunete/GeamSpateDeschis.wav", self.baseDirectory);
    self.OpenDoorStreesSoundId = createSample("OpenDoorStrees");
    loadSample(self.OpenDoorStreesSoundId, OpenDoorStreesSoundFile, false);
    self.OpenDoorStreesPlaying = false;

    OpenDoorMaskSoundFile = Utils.getFilename("Sunete/CapotaDeschisa.wav", self.baseDirectory);
    self.OpenDoorMaskSoundId = createSample("OpenDoorMask");
    loadSample(self.OpenDoorMaskSoundId, OpenDoorMaskSoundFile, false);
    self.OpenDoorMaskPlaying = false;

   OpenDoorClopSoundFile = Utils.getFilename("Sunete/CuplaActivata.wav", self.baseDirectory);
    self.OpenDoorClopSoundId = createSample("OpenDoorClop");
    loadSample(self.OpenDoorClopSoundId, OpenDoorClopSoundFile, false);
    self.OpenDoorClopPlaying = false;

    FixingSoundFile = Utils.getFilename("Sunete/Reparatii.wav", self.baseDirectory);
    self.FixingSoundId = createSample("FixingSound");
    loadSample(self.FixingSoundId, FixingSoundFile, false);
    self.FixingPlaying = false;

    SeatSoundFile = Utils.getFilename("Sunete/Scaun.wav", self.baseDirectory);
    self.SeatSoundId = createSample("SeatSound");
    loadSample(self.SeatSoundId, SeatSoundFile, false);
    self.SeatPlaying = false;
	self.SeatSoundOffset = getSampleDuration(self.SeatSoundId);

     self.lowFuelIndicatorHud = Overlay:new("lowFuelIndicatorOverlay", Utils.getFilename("Texturi/IndicatorMotorina.dds", self.baseDirectory), 0.66, 0.04, 0.080, 0.085);
	
	lowFuelSoundFile = Utils.getFilename("Sunete/IndicatorMotorina.wav", self.baseDirectory);
    self.lowFuelSoundId = createSample("LFSound");
    loadSample(self.lowFuelSoundId, lowFuelSoundFile, false);
	self.lowFuelSoundPlaying = false;
	self.playedSound = false;

     local fanSound = getXMLString(xmlFile, "vehicle.fanSound#file");
		if fanSound ~= nil and fanSound ~= "" then
			fanSound = Utils.getFilename(fanSound, self.baseDirectory);
			self.fanSound = createSample("fanSound");
			loadSample(self.fanSound, fanSound, false);
			self.fanSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fanSound#pitchOffset"), 1);
			self.fanSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fanSound#volume"), 1);
			setSamplePitch(self.fanSound, self.fanSoundPitchOffset);
			self.fanSoundTime = 0;
			self.fanSoundEnabled = false;
      end;
self.fanLed = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fanLed#index"));

    -- Generating a random number --
	self.RandomNumber = math.random(2,30);	
	--print ("nombre:" , self.RandomNumber);

    self.CapotaInRange = false;
	self.CapotaPanels = false;
	self.servicePrice = 0;
	self.awaitingFixingAck = false;
	self.servicePrice = math.random(200,1500);

    self.wellenCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Allradwellen#count"), 0);	 
	self.Wellen = {};
	self.Speed = {};
	if self.wellenCount ~= 0 and self.wellenCount ~= nil then
	    for i=1, self.wellenCount do
	        local Welle = string.format("vehicle.Allradwellen.Welle%d", i)
		    self.Wellen[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, Welle .. "#index"));
	    end;
	end;
	
	-- Optionale Ausrichtung der Welle auf die Vorderachse, nur bei Pendelachsen erforderlich)
	self.welleDirection1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Allradwellen.SetDirection#welle1"));
	self.welleDirection2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Allradwellen.SetDirection#welle2"));

	self.internalCamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.internalCamera#index"));
	self.camPositionX = 0;
	self.camPositionZ = 0;	

    self.backcamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backcamera#index"));
	
	self.AvarieCalareRadiator = {};
    local AvarieCalareRadiatorCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.AvarieCalareRadiator#count"), 0);
	for i=1, AvarieCalareRadiatorCount do
		local namei = string.format("vehicle.AvarieCalareRadiator.part%d", i);
		local nodei = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.AvarieCalareRadiator, namei, self.components, false, nil, self.baseDirectory)
    end;
	
	self.AvarieGripareMotor = {};
    local AvarieGripareMotorCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.AvarieGripareMotor#count"), 0);
	for i=1, AvarieGripareMotorCount do
		local namei = string.format("vehicle.AvarieGripareMotor.part%d", i);
		local nodei = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.AvarieGripareMotor, namei, self.components, false, nil, self.baseDirectory)
    end;


self.cameraRotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.cameraRotNode#index"));
self.seatNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.seatNode#index"));
self.farmerNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.characterNode#index"));

	if self.cameraRotNode ~=nil then
		local x,y,z = getTranslation(self.cameraRotNode);
		self.startXTranslation = x;
		self.startYTranslation = y;
		self.startZTranslation = z;
	end; 

if self.seatNode ~=nil then
		local x,y,z = getTranslation(self.seatNode);
		self.startSeatXTranslation = x;
		self.startSeatYTranslation = y;
		self.startSeatZTranslation = z;
	end;

	if self.farmerNode ~=nil then
		local x,y,z = getTranslation(self.farmerNode);
		self.startFarmerXTranslation = x;
		self.startFarmerYTranslation = y;
		self.startFarmerZTranslation = z;
	end;
	
    self.maxTranslationPrCycle = 0.0001;
	
	if self.wheels[3].repr ~= nil and self.wheels[4].repr ~= nil and self.wheels[1].repr ~= nil and self.wheels[2].repr ~= nil then
		local x,y,z = getTranslation(self.wheels[3].repr);
		local x2,y2,z2 = getTranslation(self.wheels[4].repr);
		local x3,y3,z3 = getTranslation(self.wheels[1].repr);
		local x4,y4,z4 = getTranslation(self.wheels[2].repr);
		self.wheelYTranslationDifference = self.startYTranslation - y;
		self.frontAndRearWheelYTranslationDifference = y - y4;		
		self.averageYTranslation = (y + y2)/2;
		self.averageYTranslationCamFront = (y3 + y4)/2;
	end;	
	self.camTranslation = self.averageYTranslation;
	

    self.wipers = {};
	self.wipers.anim = getXMLString(xmlFile, "vehicle.wiper#animName");
	self.wipers.speed = getXMLFloat(xmlFile, "vehicle.wiper#speed");
	self.wipers.isActive = false;

local i=0;
    while true do
        local baseName = string.format("vehicle.attacherJoints.attacherJoint(%d)", i);
        local index = getXMLString(xmlFile, baseName.. "#index");
        if index == nil then
            break;
        end;		
		local joint = self.attacherJoints[i+1];
		local shaftAttacher = Utils.indexToObject(self.components, getXMLString(xmlFile, baseName .. "#shaft"));
		if shaftAttacher ~= nil then
			joint.powerShaftAttacher = shaftAttacher;
		end;
		i = i + 1;
	end;
	local attacherJointCount = i;
	i = 0;
    while true do
        local baseName = string.format("vehicle.trailerAttacherJoints.trailerAttacherJoint(%d)", i);
        local index = getXMLString(xmlFile, baseName.. "#index");
        if index == nil then
            break;
        end;
		
		local joint = self.attacherJoints[attacherJointCount + 1 + i];
		local shaftAttacher = Utils.indexToObject(self.components, getXMLString(xmlFile, baseName .. "#shaft"));
		if shaftAttacher ~= nil then
			joint.powerShaftAttacher = shaftAttacher;
		end;
        i = i+1;
    end;	

self.cylinders = {};
	local i = 0;
	while true do
		local nameStr = string.format("vehicle.hydraulicCylinders.hydraulicCylinder(%d)", i);
        local cylinder = {};
        local cylinderStr = getXMLString(xmlFile, nameStr .. "#cylinder");
        if cylinderStr == nil then
            break;
        end;
        cylinder.index = Utils.indexToObject(self.components, cylinderStr);
        cylinder.directionFix = Utils.indexToObject(self.components, getXMLString(xmlFile, nameStr .. "#cylinderFix"));
		cylinder.punch = Utils.indexToObject(self.components, getXMLString(xmlFile, nameStr .. "#punch"));
		if cylinder.punch ~= nil then
			cylinder.translationFix = Utils.indexToObject(self.components, getXMLString(xmlFile, nameStr .. "#punchFix"));
			local ax, ay, az = getWorldTranslation(cylinder.punch);
			local bx, by, bz = getWorldTranslation(cylinder.translationFix);		
			cylinder.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		end;
		cylinder.scalePunch = Utils.getNoNil(getXMLBool(xmlFile, nameStr .. "#scale"), false);
		table.insert(self.cylinders, cylinder);
		i = i + 1;
	end;
	
	
end;
function UTB1010DT:delete()
Utils.deleteParticleSystem(self.AvarieCalareRadiator);
Utils.deleteParticleSystem(self.AvarieGripareMotor);

 if self.OpenDoorLifeSoundId ~= nil then
        stopSample(self.OpenDoorLifeSoundId);
    end;	

 if self.OpenDoorRightSoundId ~= nil then
        stopSample(self.OpenDoorRightSoundId);
    end;	

if self.OpenDoorStreesSoundId ~= nil then
        stopSample(self.OpenDoorStreesSoundId);
    end;	

if self.OpenDoorMaskSoundId ~= nil then
        stopSample(self.OpenDoorMaskSoundId);
    end;	

if self.OpenDoorClopSoundId ~= nil then
        stopSample(self.OpenDoorClopSoundId);
    end;	
 if self.FixingSoundId ~= nil then
        stopSample(self.FixingSoundId);
    end;
if self.SeatPlaying ~= nil then
		stopSample(self.SeatSoundId);
	end;
if self.fanSound ~= nil then
          delete(self.fanSound);
	end;
end;

function UTB1010DT:mouseEvent(posX, posY, isDown, isUp, button)
end;

function UTB1010DT:keyEvent(unicode, sym, modifier, isDown)
if isDown and sym == Input.KEY_f2 then
self.rotationMaxwajcha5 = not self.rotationMaxwajcha5;
end;

if isDown and sym == Input.KEY_f3 then
self.rotationMaxwajcha6 = not self.rotationMaxwajcha6;
end;

if isDown and sym == Input.KEY_f4 then
self.rotationMaxwajcha7 = not self.rotationMaxwajcha7;
end;

if isDown and sym == Input.KEY_v then
self.rotationMaxwajcha8 = not self.rotationMaxwajcha8;
end;

if isDown and sym == Input.KEY_KP_enter then
self.rotationMaxwajcha9 = not self.rotationMaxwajcha9;
end;

 if Input.isKeyPressed(Input.KEY_KP_period) then
  self.rotationMaxCheieContact = true;
 else
  self.rotationMaxCheieContact = false;
end;
end;
function UTB1010DT:update(dt)	
if g_currentMission.player ~= nil then
local nearestDistance = 2.5; 
		local px, py, pz = getWorldTranslation(self.GeamSpate.node); 
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode); 
		local distance1 = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance1 < nearestDistance then
			self.inrange = true; 
		else
			self.inrange = false; 
		end;
	end;

local nearestDistance = 3.0 --max distance allowed
	local px, py, pz = getWorldTranslation(self.rotationUsaStanga.node); --self.Helice1 is one of the spereaders
	local vx, vy, vz = getWorldTranslation(getCamera());
	if vx ~= nil and  vy ~= nil and vz ~= nil then
		local distance2 = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance2 < nearestDistance then
			self.UsaStangaInRange = true; --farmer is in range
		else
			self.UsaStangaInRange = false; --farmer is not in range
		end;
	end;

local nearestDistance = 3.0; --max distance allowed
	local px, py, pz = getWorldTranslation(self.rotationUsaDreapta.node); --self.Helice1 is one of the spereaders
	local vx, vy, vz = getWorldTranslation(getCamera());
	if vx ~= nil and  vy ~= nil and vz ~= nil then
		local distance3 = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance3 < nearestDistance then
			self.UsaDreaptaInRange = true; --farmer is in range
		else
			self.UsaDreaptaInRange = false; --farmer is not in range
		end;
	end;

local nearestDistance = 1.5; --max distance allowed
	local px, py, pz = getWorldTranslation(self.rotationCapota.node); --self.Helice1 is one of the spereaders
	local vx, vy, vz = getWorldTranslation(getCamera());
	if vx ~= nil and  vy ~= nil and vz ~= nil then
		local distance4 = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance4 < nearestDistance then
			self.CapotaInRange = true; --farmer is in range
		else
			self.CapotaInRange = false; --farmer is not in range
		end;
	end;

local nearestDistance = 3.0; --max distance allowed
	local px, py, pz = getWorldTranslation(self.rotationCupla.node); --self.Helice1 is one of the spereaders
	local vx, vy, vz = getWorldTranslation(getCamera());
	if vx ~= nil and  vy ~= nil and vz ~= nil then
		local distance5 = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance5 < nearestDistance then
			self.CuplaInRange = true; --farmer is in range
		else
			self.CuplaInRange = false; --farmer is not in range
		end;
	end;


if InputBinding.hasEvent(InputBinding.DeschideUsaStanga) then
		if 	self.UsaStangaInRange then
			self.UsaStangaPanels = not self.UsaStangaPanels;
			--if Player:getIsActiveForSound() then
				if not self.FixingPlaying then
					playSample(self.OpenDoorLifeSoundId, 1, 3, 3);
				end;
			--end;
		end;
	end;

if InputBinding.hasEvent(InputBinding.DeschideUsaDreapta) then
		if 	self.UsaDreaptaInRange then
			self.UsaDreaptaPanels = not self.UsaDreaptaPanels;
			--if Player:getIsActiveForSound() then
				if not self.FixingPlaying then
					playSample(self.OpenDoorRightSoundId, 1, 3, 3);
				end;
			--end;
		end;
	end;

if InputBinding.hasEvent(InputBinding.DeschideGeamSpate) then
		if self.inrange or self.isEntered then
			self.openGeamSpate = not self.openGeamSpate;
			--if Player:getIsActiveForSound() then
				if not self.FixingPlaying then
					playSample(self.OpenDoorStreesSoundId, 1, 3, 3);
				end;
			--end;
		end;
	end;

if InputBinding.hasEvent(InputBinding.DeschideCapota) then
		if 	self.CapotaInRange then
			self.CapotaPanels = not self.CapotaPanels;
			--if Player:getIsActiveForSound() then
				if not self.FixingPlaying then
					playSample(self.OpenDoorMaskSoundId, 1, 3, 3);
				end;
			--end;
		end;
	end;

if InputBinding.hasEvent(InputBinding.AtaseazaCupla) then
		if 	self.CuplaInRange then
			self.CuplaPanels = not self.CuplaPanels;
			--if Player:getIsActiveForSound() then
				if not self.FixingPlaying then
					playSample(self.OpenDoorClopSoundId, 1, 3, 3);
				end;
			--end;
		end;
	end;

if InputBinding.hasEvent(InputBinding.ReparatiiTractor) then
		if 	self.CapotaInRange and self.CapotaPanels then
			--if Player:getIsActiveForSound() then
			self.awaitingFixingAck = true;
			--end;
		end;
	end;

if InputBinding.hasEvent(InputBinding.ReparaTractorul) then
		if self.awaitingFixingAck then
			self.awaitingFixingAck = false;
			self.Breakdown = false;
			self.AuthorizeBreakdown = true;
			self.RandomNumber = self.RandomNumber + math.random(10,30);
			if not self.FixingPlaying then
				playSample(self.FixingSoundId, 1, 1, 0);
			end;
			--Fixing costs money!!!
            g_currentMission.missionStats.expensesTotal = g_currentMission.missionStats.expensesTotal + self.servicePrice;
            g_currentMission.missionStats.expensesSession = g_currentMission.missionStats.expensesSession + self.servicePrice;

            g_currentMission.missionStats.money = g_currentMission.missionStats.money - self.servicePrice;
			self.servicePrice = math.random(200,1500);
		end;
	end;

if InputBinding.hasEvent(InputBinding.NuReparaTractorul) then
		if self.awaitingFixingAck then
			self.awaitingFixingAck = false;
		end;
	end;

if self.awaitingFixingAck then
		setTextColor(1, 0, 0, 1.0);
		renderText(0.25, 0.5, 0.03, string.format("Reparatiile La Tractorul Universal 1010 DT Are Un Pret De: " ..self.servicePrice.. " RON? B/N"));
	end;

--renderText(0.5, 0.5, 0.020, string.format("%d ",self.RandomNumber));

-- Breakdown OFF : open the panel if HectarTreshed == random number -- 
  
    if self.UsaStangaInRange then
		if not self.UsaStangaPanels then
			g_currentMission:addExtraPrintText(string.format("Key %s: Deschide Usa Stanga", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideUsaStanga)));
		else
			g_currentMission:addExtraPrintText(string.format("Key %s: Inchide Usa Stanga", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideUsaStanga)));
		end;
	end;
    

     if self.UsaDreaptaInRange then
		if not self.UsaDreaptaPanels then
			g_currentMission:addExtraPrintText(string.format("Key %s: Deschide Usa Dreapta", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideUsaDreapta)));
		else
			g_currentMission:addExtraPrintText(string.format("Key %s: Inchide Usa Dreapta", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideUsaDreapta)));
		end;
	end;


     if self.CapotaInRange then
		if not self.CapotaPanels then
			g_currentMission:addExtraPrintText(string.format("Key %s: Deschide Capota", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideCapota)));
		else
			g_currentMission:addExtraPrintText(string.format("Key %s: Inchide Capota", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideCapota)));
               g_currentMission:addExtraPrintText(string.format("Key %s: Reparatii Tractor Universal 1010 DT", InputBinding.getKeyNamesOfDigitalAction(InputBinding.ReparatiiTractor)));
		end;
	end;

     if self.CuplaInRange then
		if not self.CuplaPanels then
			g_currentMission:addExtraPrintText(string.format("Key %s: Ataseaza Cupla", InputBinding.getKeyNamesOfDigitalAction(InputBinding.AtaseazaCupla)));
		else
			g_currentMission:addExtraPrintText(string.format("Key %s: Dezataseaza Cupla", InputBinding.getKeyNamesOfDigitalAction(InputBinding.AtaseazaCupla)));
		end;
	end;

     
     local doRotate = self.rotationUsaStangaMax or self.rotationUsaStangaMin 
	if self.rotationUsaStanga ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationUsaStanga.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationUsaStanga.maxRot, self.rotationUsaStanga.minRot, 3, self.rotationUsaStanga.rotTime, dt, not self.rotationUsaStangaMax);
        setRotation(self.rotationUsaStanga.node, unpack(newRot));
    end;


   local doRotate = self.rotationUsaDreaptaMax or self.rotationUsaDreaptaMin 
	if self.rotationUsaDreapta ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationUsaDreapta.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationUsaDreapta.maxRot, self.rotationUsaDreapta.minRot, 3, self.rotationUsaDreapta.rotTime, dt, not self.rotationUsaDreaptaMax);
        setRotation(self.rotationUsaDreapta.node, unpack(newRot));
    end;


   if self.GeamSpate ~= nil then
		local x, y, z = getRotation(self.GeamSpate.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.GeamSpate.minRot, self.GeamSpate.maxRot, 3, self.GeamSpate.rotTime, dt, self.openGeamSpate);
		setRotation(self.GeamSpate.node, unpack(newRot));
	end;


    local doRotate = self.rotationCuplaMax or self.rotationCuplaMin 
	if self.rotationCupla ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationCupla.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationCupla.maxRot, self.rotationCupla.minRot, 3, self.rotationCupla.rotTime, dt, not self.rotationCuplaMax);
        setRotation(self.rotationCupla.node, unpack(newRot));
    end;

      local doRotate = self.rotationCapotaMax or self.rotationCapotaMin 
	if self.rotationCapota ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationCapota.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationCapota.maxRot, self.rotationCapota.minRot, 3, self.rotationCapota.rotTime, dt, not self.rotationCapotaMax);
        setRotation(self.rotationCapota.node, unpack(newRot));
    end;


     if self.UsaStangaPanels then
		self.rotationUsaStangaMax = true;		
		self.rotationUsaStangaMin = false;
	else
		self.rotationUsaStangaMax = false;
		self.rotationUsaStangaMin = true;
	end;

    if self.UsaDreaptaPanels then
         self.rotationUsaDreaptaMax = true;		
		self.rotationUsaDreaptaMin = false;
	else
         self.rotationUsaDreaptaMax = false;
		self.rotationUsaDreaptaMin = true;
	end;
  
     if self.CapotaPanels then
         self.rotationCapotaMax = true;		
		self.rotationCapotaMin = false;
	else
         self.rotationCapotaMax = false;
		self.rotationCapotaMin = true;
	end;

    if self.CuplaPanels then
         self.rotationCuplaMax = true;		
		self.rotationCuplaMin = false;
	else
         self.rotationCuplaMax = false;
		self.rotationCuplaMin = true;
	end;


      if self.isMotorStarted then
		self.bujaj = self.bujaj - dt;
		if self.bujaj < 0 then
			self.bujaniekabiny = not self.bujaniekabiny;
			self.bujaj = 80;
		end;
	end;	
	if self.rotationPartbujanie ~= nil then
		local x, y, z = getRotation(self.rotationPartbujanie.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartbujanie.maxRot, self.rotationPartbujanie.minRot, 3, self.rotationPartbujanie.rotTime, dt, not self.bujaniekabiny);
		setRotation(self.rotationPartbujanie.node, unpack(newRot));
  	end;	


	if self.isMotorStarted then
		if self.rotationPartCarburant ~= nil then
			local x, y, z = getRotation(self.rotationPartCarburant.node);
			z = ((self.rotationPartCarburant.maxRot[3] - self.rotationPartCarburant.minRot[3]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartCarburant.minRot[3];
			setRotation(self.rotationPartCarburant.node, x, y ,z);
		end;
			
		if self.rotationPartPresiuneUlei ~= nil then
			setRotation(self.rotationPartPresiuneUlei.node, 0, 0, Utils.degToRad(-50));
		end; 
		
	if self.rotationPartTemperaturaApa ~= nil then
		local x, y, z = getRotation(self.rotationPartTemperaturaApa.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartTemperaturaApa.minRot, self.rotationPartTemperaturaApa.maxRot, 3, self.rotationPartTemperaturaApa.rotTime, dt, 1);
		setRotation(self.rotationPartTemperaturaApa.node, unpack(newRot));
	end;		
		
	else
		setRotation(self.rotationPartCarburant.node, 0, 0 , 0);
		setRotation(self.rotationPartPresiuneUlei.node, 0, 0 , 0);
		setRotation(self.rotationPartTemperaturaApa.node, 0, 0 , 0);
	end;
	
		if self.isMotorStarted then
			if self.currentCycle < self.cycleRoundMax then
				self.currentCycle = self.currentCycle + 1;
				self.currentRPM = self.motor.lastMotorRpm;
				if self.rpmMeterValue ~= nil then
					self.currentRPM = self.rpmMeterValue;
				end;
				self.lastRpm = math.floor((self.lastRpm + self.currentRPM)/2);
		end;
	if self.isMotorStarted then
		if self.rotationPartTurometru ~= nil then
			local x, y, z = getRotation(self.rotationPartTurometru.node);
			z = ((self.rotationPartTurometru.maxRot[3] - self.rotationPartTurometru.minRot[3]) / 2750) * 	self.rpmMeterValue + self.rotationPartTurometru.minRot[3];
			setRotation(self.rotationPartTurometru.node, x, y ,z);
		end;
	else
		setRotation(self.rotationPartTurometru.node, 0, 0 , 0);
	 end;
  end;	

     if self.rotationPartwajcha5 ~= nil then
    local x, y, z = getRotation(self.rotationPartwajcha5.node);
    local rot = {x,y,z};
    local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha5.maxRot, self.rotationPartwajcha5.minRot, 3, self.rotationPartwajcha5.rotTime, dt, not self.rotationMaxwajcha5);
    setRotation(self.rotationPartwajcha5.node, unpack(newRot));
       end;


     if self.rotationPartwajcha6 ~= nil then
    local x, y, z = getRotation(self.rotationPartwajcha6.node);
    local rot = {x,y,z};
    local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha6.maxRot, self.rotationPartwajcha6.minRot, 3, self.rotationPartwajcha6.rotTime, dt, not self.rotationMaxwajcha6);
    setRotation(self.rotationPartwajcha6.node, unpack(newRot));
       end;
 
       if self.rotationPartwajcha7 ~= nil then
    local x, y, z = getRotation(self.rotationPartwajcha7.node);
    local rot = {x,y,z};
    local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha7.maxRot, self.rotationPartwajcha7.minRot, 3, self.rotationPartwajcha7.rotTime, dt, not self.rotationMaxwajcha7);
    setRotation(self.rotationPartwajcha7.node, unpack(newRot));
       end;

     if self.rotationPartwajcha8 ~= nil then
    local x, y, z = getRotation(self.rotationPartwajcha8.node);
    local rot = {x,y,z};
    local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha8.maxRot, self.rotationPartwajcha8.minRot, 3, self.rotationPartwajcha8.rotTime, dt, not self.rotationMaxwajcha8);
    setRotation(self.rotationPartwajcha8.node, unpack(newRot));
       end;

    if self.rotationPartwajcha9 ~= nil then
    local x, y, z = getRotation(self.rotationPartwajcha9.node);
    local rot = {x,y,z};
    local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha9.maxRot, self.rotationPartwajcha9.minRot, 3, self.rotationPartwajcha9.rotTime, dt, not self.rotationMaxwajcha9);
    setRotation(self.rotationPartwajcha9.node, unpack(newRot));
       end;

        if self.isMotorStarted then
		self.rotationMaxCheieContact = true;
	else
		self.rotationMaxCheieContact = false;
	end; 

         if self.rotationPartCheieContact ~= nil then
    local x, y, z = getRotation(self.rotationPartCheieContact.node);
    local rot = {x,y,z};
    local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartCheieContact.maxRot, self.rotationPartCheieContact.minRot, 3, self.rotationPartCheieContact.rotTime, dt, not self.rotationMaxCheieContact);
    setRotation(self.rotationPartCheieContact.node, unpack(newRot));
       end;


      if self.rotationMaxwajcha5 and not self.isEntered then
self.rotationMaxwajcha5 = false;
end;

 if self.rotationMaxwajcha6 and not self.isEntered then
self.rotationMaxwajcha6 = false;
end;

 if self.rotationMaxwajcha7 and not self.isEntered then
self.rotationMaxwajcha7 = false;
end;

 if self.rotationMaxwajcha8 and not self.isEntered then
self.rotationMaxwajcha8 = false;
end;

 if self.rotationMaxwajcha9 and not self.isEntered then
self.rotationMaxwajcha9 = false;
end;

   --local rpm = self.rpmNum;
	local rpm = 3;
	local engineRpm = 3;
	
	--if self.rpmMeterValue ~= nil then
	if self.isMotorStarted then
		rpm = self.rpmMeterValue / self.motorMaxRpmLimit[3] * 3;
	end;
	
	if rpm > 3 then
		rpm = 3;
	end;
	
	engineRpm = rpm;

if self.isMotorStarted then
		rotate(self.Ventilator, dt * 0.008 * rpm, 0, 0);
		self.engineRunTime = dt + self.engineRunTime;
	else
		self.engineRunTime = 0;
	end;

if self.isMotorStarted then
		rotate(self.VentilatorAlternator, dt * 0.008 * rpm, 0, 0);
		self.engineRunTime = dt + self.engineRunTime;
	else
		self.engineRunTime = 0;
	end;

if self.isMotorStarted then
		rotate(self.Rola, dt * 0.008 * rpm, 0, 0);
		self.engineRunTime = dt + self.engineRunTime;
	else
		self.engineRunTime = 0;
	end;

if self.isMotorStarted then
		rotate(self.Rola1, dt * 0.008 * rpm, 0, 0);
		self.engineRunTime = dt + self.engineRunTime;
	else
		self.engineRunTime = 0;
	end;

	if self.isMotorStarted then	
			setVisibility(self.batteriaicona, false);
			setVisibility(self.olioicona, false);
               setVisibility(self.olioicona2, false);
		else			
			setVisibility(self.batteriaicona, true);
			setVisibility(self.olioicona, true);		
               setVisibility(self.olioicona2, true);		
		end;

 
         if self.attacherJoints[1] ~= nil then
		if self.attacherJoints[1].maxRot[1] ~= nil then
			if not self.liftInitialized then
				self.maxLiftDebth = self.attacherJoints[1].maxRot[1];
				self.minLiftDebth = self.attacherJoints[1].minRot[1];
				self.liftInitialized = true;
			end;
		end;
	end;  
				
	if self.frontAxle.rotNode ~= nil and self.wheels[1].repr ~= nil and self.wheels[2].repr ~= nil then
		local ax, ay, az = getWorldTranslation(self.wheels[1].repr);
        local bx, by, bz = getWorldTranslation(self.wheels[2].repr);
		
		local x, y, z = worldDirectionToLocal(getParent(self.frontAxle.rotNode), bx-ax, by-ay, bz-az);
		
        setDirection(self.frontAxle.rotNode, x, y, z, 1, 0, 1);
		
		local x2,y2,z2 = getRotation(self.frontAxle.rotNode);
		setRotation(self.frontAxle.rotNode,x2 - 1.571,y2,z2 + 1.571);
	end;
	
	for i=1, self.numAnimatedWheels do
		if self.wheels[i].repr ~= nil then
			local x,y,z = getRotation(self.wheels[i].driveNode);
			local x2,y2,z2 = getRotation(self.wheels[i].repr);
			setRotation(self.animatedWheel[i].wheel, x,y,z);
			setRotation(self.animatedWheel[i].rotNode, x2,y2,z2);
		end;
	end;

	
	if self.frontAxle.steeringHydraulicsLeft ~= nil and self.frontAxle.steeringPushLeftAttach ~= nil then
		local ax, ay, az = getWorldTranslation(self.frontAxle.steeringHydraulicsLeft);
        local bx, by, bz = getWorldTranslation(self.frontAxle.steeringPushLeftAttach);

		
		local x, y, z = worldDirectionToLocal(getParent(self.frontAxle.steeringHydraulicsLeft), bx-ax, by-ay, bz-az);
        setDirection(self.frontAxle.steeringHydraulicsLeft, x, y, z, 0, -1, 0);
		
		local x,y,z = getRotation(self.animatedWheel[1].rotNode);
		self.translation = -0.17 * math.tan(y);
		setTranslation(self.frontAxle.steeringPushLeft,(self.translation)*0.7,0,0);	
	end;
	
	if self.frontAxle.steeringHydraulicsRight ~= nil and self.frontAxle.steeringPushRightAttach ~= nil then
		local ax, ay, az = getWorldTranslation(self.frontAxle.steeringPushRightAttach);
        local bx, by, bz = getWorldTranslation(self.frontAxle.steeringHydraulicsRight);

		
		local x, y, z = worldDirectionToLocal(getParent(self.frontAxle.steeringHydraulicsRight), bx-ax, by-ay, bz-az);
        setDirection(self.frontAxle.steeringHydraulicsRight, x, y, z, 0, 1, 0);
		
		local x,y,z = getRotation(self.animatedWheel[2].rotNode);
		self.translation = 0.17 * math.tan(y);
		setTranslation(self.frontAxle.steeringPushRight,(self.translation)*0.7,0,0);
	end;
	
	if self.animatedWheel[1].fenderAttach ~= nil and self.animatedWheel[2].fenderAttach ~= nil then
		local ax, ay, az = getWorldTranslation(self.animatedWheel[1].fenderAttach);
        local bx, by, bz = getWorldTranslation(self.animatedWheel[2].fenderAttach);
		
		local x, y, z = worldDirectionToLocal(getParent(self.animatedWheel[2].fenderAttach), bx-ax, by-ay, bz-az);
        setDirection(self.animatedWheel[1].fenderAttach, x, y, z, 0, 1, 0);
		
	end;

 if self:getIsActive() then
		-- Rotation vom Lenkrad abgreifen
		local rx, ry, rz = getRotation(self.steering);
		local rw1 = (ry / self.sv2.berDiv);
		
		-- Nachdem die Rotation durch den vorgegebenen Wert berDiv (Standart 45) geteitl wurde folgt die Aufteilung in Links und Rechts Werte
		local rwLeft = 0;
		local rwRight = 0;
		if ry > 0 then -- positive Rotation d. Lenkrads --> Links mehr Sturz als Rechts
			rwLeft = rw1 
			rwRight = rw1*self.sv2.leftRightDifference
		elseif ry < 0 then -- negative Rotation d. Lenkrads --> Rechts mehr Sturz als Links
			rwLeft = rw1*self.sv2.leftRightDifference		 
			rwRight = rw1
		end;
		-- und die Umsetzung der Rotation
		setRotation(self.sv2.fenderLeft, 0, 0, -rwLeft);
		setRotation(self.sv2.fenderRight, 0, 0, -rwRight);
	end;

       if self:getIsActive() then	
	    if self.wellenCount ~= 0 and self.wellenCount ~= nil then
		  local getRx, getRy, getRz = getRotation(self.wheels[3].repr);			
	      for i=1, self.wellenCount do
	        setRotation(self.Wellen[i], 0, 0, getRx*10);
	      end;
	    end;	
		
		-- Ausrichtung der Allradwelle auf die Vorderachse (Nur bei Pendelachsen erforderlich) --
		if self.welleDirection1 ~= nil and self.welleDirection2 ~= nil then
			local a2x, a2y, a2z = getWorldTranslation(self.welleDirection1);
			local b2x, b2y, b2z = getWorldTranslation(self.welleDirection2);
			x2, y2, z2 = worldDirectionToLocal(getParent(self.welleDirection1), b2x-a2x, b2y-a2y, b2z-a2z);
			setDirection(self.welleDirection1, x2, y2, z2, 0, 1, 0);			
			local a3x, a3y, a3z = getWorldTranslation(self.welleDirection2);
			local b3x, b3y, b3z = getWorldTranslation(self.welleDirection1);
			x3, y3, z3 = worldDirectionToLocal(getParent(self.welleDirection2), b3x-a3x, b3y-a3y, b3z-a3z);
			setDirection(self.welleDirection2, x3, y3, z3, 0, 1, 0);
		end;		
    end; 

	if self.isEntered then
		
		if InputBinding.isPressed(InputBinding.MOVECAMLEFT) then
			self.camPositionX = self.camPositionX + 0.02;
			if self.camPositionX >= 0.3 then
				self.camPositionX = 0.3;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMRIGHT) then
			self.camPositionX = self.camPositionX - 0.02;
			if self.camPositionX <= -0.3 then
				self.camPositionX = -0.3;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMFORWARD) then
			self.camPositionZ = self.camPositionZ + 0.02;
			if self.camPositionZ >= 0.3 then
				self.camPositionZ = 0.3;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMBACK) then
			self.camPositionZ = self.camPositionZ - 0.02;
			if self.camPositionZ <= -0.3 then
				self.camPositionZ = -0.3;
			end;
		end;
		
		if InputBinding.hasEvent(InputBinding.MOVECAMRESET) then
			self.camPositionX = 0;
			self.camPositionZ = 0;
		end;
		
		if self.internalCamera ~= nil then
			setTranslation(self.internalCamera, self.camPositionX, 0, self.camPositionZ);
		end;		
	end;	

        if self.isEntered then

        if Input.isKeyPressed(Input.KEY_lshift) then
                setCamera(self.backcamera);
       	end;
end;

         if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.UTB1010DTAjutor) then
			self.UTB1010DTAjutor = not self.UTB1010DTAjutor;
		end;
	end;

if self:getIsActiveForInput() then
        if InputBinding.isPressed(InputBinding.mehrRPM) then
		    self.motor.minRpm = self.motor.minRpm - 25;
		elseif InputBinding.isPressed(InputBinding.wenigerRPM) then
		    self.motor.minRpm = self.motor.minRpm + 25;
	    end;
    end;

    if self.isEntered then
		if self.motor.minRpm < -3000 then
			self.motor.minRpm = -3000;
		elseif self.motor.minRpm > 200 then
			self.motor.minRpm = 200;
		end;
	end;
	
	if getUserInRange(self.rootNode, 6) then
 if Input.isKeyPressed(Input.KEY_r) then
     self.AcoperireGripareMotor = true;
     else
     self.AcoperireGripareMotor = false;
	 end;
end; 	

if self.isMotorStarted then
if self.TimpGripareMotor <= 2950000 then
   self.TimpGripareMotor = self.TimpGripareMotor +(dt/1);
 end;
 end; 

if self.TimpGripareMotor >= 2950000 then
  self.AvertizareGripareMotor = true;
 Utils.setEmittingState(self.AvarieGripareMotor, true)
 else
  self.AvertizareGripareMotor = false;
 Utils.setEmittingState(self.AvarieGripareMotor, false)
 end;

 if self.AcoperireGripareMotor then
 if self.AvertizareGripareMotor then
 self.TimpGripareMotor = 0;
 self.AvertizareGripareMotor = false;
 Utils.setEmittingState(self.extraExhaustParticleSystems, false)
 self.handbrake = false;
 end;
 end;
 
  if self.AvertizareGripareMotor then 
       self.isMotorStarted = true;
       self.MotorMaschineActive = true;
       self:stopMotor();
       self.steeringEnabled = true;
       self.allowedIgnition = false;
       setVisibility(self.aiMotorSound, false);
       Utils.setEmittingState(self.extraExhaustParticleSystems, false)
       Utils.setEmittingState(self.extraExhaustParticleSystems, false)
       Utils.setEmittingState(self.extraExhaustParticleSystems, false)
       Utils.setEmittingState(self.extraExhaustParticleSystems, false)
       self.handbrake = true;
 end;
	

if getUserInRange(self.rootNode, 6) then
 if Input.isKeyPressed(Input.KEY_b) then
     self.AcoperireCalareRadiator = true;
     else
     self.AcoperireCalareRadiator = false;
	 end;
end; 	

if self.isMotorStarted then
if self.TimpCalareRadiator <= 1850000 then
   self.TimpCalareRadiator = self.TimpCalareRadiator +(dt/1);
 end;
 end; 

if self.TimpCalareRadiator >= 1850000 then
  self.AvertizareCalareMotor = true;
 Utils.setEmittingState(self.AvarieCalareRadiator, true)
 else
  self.AvertizareCalareMotor = false;
 Utils.setEmittingState(self.AvarieCalareRadiator, false)
 end;

 if self.AcoperireCalareRadiator then
 if self.AvertizareCalareMotor then
 self.TimpCalareRadiator = 0;
 self.AvertizareCalareMotor = false;
 Utils.setEmittingState(self.extraExhaustParticleSystems, false)
 self.handbrake = false;
 end;
 end;
 
  if self.AvertizareCalareMotor then 
       self.isMotorStarted = true;
       self.MotorMaschineActive = true;
       self:stopMotor();
       self.steeringEnabled = true;
       self.allowedIgnition = false;
       setVisibility(self.aiMotorSound, false);
       Utils.setEmittingState(self.extraExhaustParticleSystems, false)
       Utils.setEmittingState(self.extraExhaustParticleSystems, false)
       Utils.setEmittingState(self.extraExhaustParticleSystems, false)
       Utils.setEmittingState(self.extraExhaustParticleSystems, false)
       self.handbrake = true;
 end;
	
	if self.cameraRotNode ~= nil and self.wheels[3].repr ~= nil and self.wheels[4].repr ~= nil then
		local ax, ay, az = getTranslation(self.wheels[3].repr);
        local bx, by, bz = getTranslation(self.wheels[4].repr);
		local cx, cy, cz = getTranslation(self.wheels[1].repr);
		local dx, dy, dz = getTranslation(self.wheels[2].repr);


		self.averageYTranslation = (ay + by)/2;
		self.averageYTranslationCamFront = (cy + dy)/2;

		self.averageYTranslationCamFront = self.averageYTranslationCamFront + self.frontAndRearWheelYTranslationDifference;
	end;
	
	self.playSeatSound = false;
	if self.camTranslation > self.averageYTranslation then
		self.camTranslation = self.camTranslation - self.maxTranslationPrCycle * dt;
		if self.camTranslation < self.averageYTranslation then
			self.camTranslation = self.averageYTranslation;
		end;
	elseif self.camTranslation < self.averageYTranslation then
		self.camTranslation = self.camTranslation + self.maxTranslationPrCycle * dt;
		if self.camTranslation > self.averageYTranslation then
			self.camTranslation = self.averageYTranslation;
		end;
		if self.camTranslation < self.averageYTranslation - 1 and self.isEntered then
			self.playSeatSound = true;
		end;
	end;
	
	if self.cameraRotNode ~= nil then
		setTranslation(self.cameraRotNode, self.startXTranslation, self.camTranslation + self.wheelYTranslationDifference, self.startZTranslation);
	end;

     if self.seatNode ~= nil then
		setTranslation(self.seatNode, self.startSeatXTranslation, self.startSeatYTranslation + self.startSeatZTranslation);
	end;
	
	if self.farmerNode ~= nil then
		setTranslation(self.farmerNode, self.startFarmerXTranslation, self.startFarmerYTranslation + self.startFarmerZTranslation);
	end;



if self.cameraRotNode ~= nil and self.camIndex == self.indoorCamIndex then		
		if self.playSeatSound then
			if not self.SeatPlaying then
				playSample(self.SeatSoundId, 1, 3, 3);
				self.SeatPlaying = true;
			end;
		else
			if self.SeatPlaying then
				stopSample(self.SeatSoundId);
				self.SeatPlaying = false;
			end;
		end;
	else
		if self.SeatPlaying then
			stopSample(self.SeatSoundId);
			self.SeatPlaying = false;
		end;	
	end;

if self.fuelFillLevel <= (self.fuelCapacity / 100) * 15 then -- Hier die 20 in eine beliebige andere Zahl ndern! Die 20 steht fr 20% Resttankvolumen.
		self.lowFuelIndicatorHud:render();
		if self.playedSound == false then
			playSample(self.lowFuelSoundId,1,1,0);
			self.playedSound = true;
		end;
		else
			self.playedSound = false;
	end;

if self.isMotorStarted then
  
         if self:getIsActiveForSound() then
 
            if self.fanSound ~= nil and not self.fanSoundEnabled and self.fanSoundTime <= self.time then
                  playSample(self.fanSound, 1, self.fanSoundVolume, 0);
                  self.fanSoundTime = self.time + 265500;
                  self.fanSoundEnabled = true;
	
			end;
			if self.fanLed ~= nil then
				if self.fanSoundEnabled then
					setVisibility(self.fanLed, true);
				else
					setVisibility(self.fanLed, false);
				end;
			end
		end;
	end;


end;		
function UTB1010DT:stopMotor()
    self.motor.minRpm = 200;
UTB1010DT.stopSounds(self);
end;

function UTB1010DT:onLeave()
    self.motor.minRpm = 200;
UTB1010DT.stopSounds(self);
self.UTB1010DTAjutorHelp = false;
if self.wipers.isActive then
		self:stopAnimation(self.wipers.anim);	
	end;
end;
function UTB1010DT:updateTick(dt)
if self:getIsActive() then
		if self.wipers.isActive then
			if not self:getIsAnimationPlaying(self.wipers.anim) then
				self:playAnimation(self.wipers.anim, self.wipers.speed, 0, true);
			end;
		end;
		
		if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
			if not self.wipers.isActive then
				self:playAnimation(self.wipers.anim, self.wipers.speed, Utils.clamp(self:getAnimationTime(self.wipers.anim), 0, 1), true);
				self.wipers.isActive = true;
			end;
		else
			if self.wipers.isActive then
				self:setAnimationStopTime(self.wipers.anim, 1);
				self.wipers.isActive = false;
			end;
		end;
	end;

for _, cylinder in pairs(self.cylinders) do
		local ax, ay, az = getWorldTranslation(cylinder.index);
		local bx, by, bz = getWorldTranslation(cylinder.directionFix);
		local x, y, z = worldDirectionToLocal(getParent(cylinder.index), bx-ax, by-ay, bz-az);
		local xU, yU, zU = 0, 1, 0;
		if math.abs(y) > 0.99 * Utils.vector3Length(x, y, z) then
			yU = 0;
			if y > 0 then
				zU = 1;
			else
				zU = -1;
			end;
		end;
		setDirection(cylinder.index, x, y, z, xU, yU, zU);
		if cylinder.punchDistance ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			if cylinder.scalePunch then
				local xS, yS, zS = getScale(cylinder.punch);
				local newS = xS * (distance / cylinder.punchDistance);
				setScale(cylinder.punch, xS, yS, newS);
			else
				setTranslation(cylinder.punch, 0, 0, distance-cylinder.punchDistance);
			end;
		end;
	end;
end;				
function UTB1010DT:draw()
if not self.UTB1010DTAjutor then
		renderText(0.385, 0.955, 0.0255, "        Tasta LCRTL: Comenzi Universal 1010 DT");
	 else	
		renderText(0.385, 0.94, 0.025, "       - Universal 1010DT By Andrei Valenti  -");
		renderText(0.385, 0.92, 0.025, "       - Tasta S + Numpad  Period : Porneste/Opreste Motorul");
		renderText(0.385, 0.90, 0.025, "       - Tasta Numpad Enter: Cuplare/Decuplare Tractiune 4X4");
		renderText(0.385, 0.88, 0.025, "       - Tasta F5: Proiector Spate");
		renderText(0.385, 0.86, 0.025, "       - Tasta F6: Deschide/Inchide Usa Stanga");
		renderText(0.385, 0.84, 0.025, "       - Tasta F7: Deschide/Inchide Usa Dreapta");
		renderText(0.385, 0.82, 0.025, "       - Tasta F8: Deschide/Inchide Geam Spate");
		renderText(0.385, 0.80, 0.025, "       - Tasta F9: Deschide/Inchide Capota");
          renderText(0.385, 0.78, 0.025, "       - Tasta F10: Ataseaza/Dezataseaza Cupla Spate");
          renderText(0.385, 0.76, 0.025, "       - Tasta X: Ataseaza Greutati Fata");
          renderText(0.385, 0.74, 0.025, "       - Tasta Numpad Plus: Activeaza/Dezactiveaza Mod Directie Roti");
          renderText(0.385, 0.72, 0.025, "       - Tasta 5: Reseteaza Camera Din Interior");
          renderText(0.385, 0.70, 0.025, "       - Tasta 6: Misca La Stanga Camera Din Interior");
          renderText(0.385, 0.68, 0.025, "       - Tasta 7: Misca La Dreapta Camera Din Interior");
          renderText(0.385, 0.66, 0.025, "       - Tasta 8: Misca In Fata Camera Din Interior");
          renderText(0.385, 0.64, 0.025, "       - Tasta 9: Misca In Spate Camera Din Interior");
          renderText(0.385, 0.62, 0.025, "       - Tasta F11 F12: Reglaj Consum CombustibilRPM");
		renderText(0.385, 0.60, 0.025, "       - Tasta Q: Agata Utilajele De Jos");
          renderText(0.385, 0.58, 0.025, "       - Tasta B: Alimentare Tractor Cu Apa");
          renderText(0.385, 0.56, 0.025, "       - Tasta R: Alimentare Tractor Cu Ulei");
          renderText(0.385, 0.54, 0.025, "       - Tasta Z: Activeaza/Dezactiveaza Cutiea De Viteze");
          renderText(0.385, 0.52, 0.025, "       - Tasta LSHIFT: Camera Spate");
          renderText(0.385, 0.50, 0.025, "       - Tasta Numpad 7,8,9: Tureaza Reduce Motorul");
          renderText(0.385, 0.48, 0.025, "       - Tasta Numpad 1,2,3,4,5: Treapte Viteza In Fata");
          renderText(0.385, 0.46, 0.025, "       - Tasta Numpad 0,6,MULTIPLY: Treapta Viteza in Spate, Liber Reductor Mic,Mare");
          renderText(0.385, 0.44, 0.025, "       - Tasta F2: Semnalizare Stanga");
          renderText(0.385, 0.42, 0.025, "       - Tasta F3: Avarii");
          renderText(0.385, 0.40, 0.025, "       - Tasta F4: Semnalizare Dreapta");
          renderText(0.385, 0.38, 0.025, "       - Tasta F: Aprinde/Stinge Faza Scurta Si Faza Lunga");
          renderText(0.385, 0.36, 0.025, "       - Tasta H: Servis Universal 1010 DT");
          renderText(0.385, 0.34, 0.025, "       - Tasta Y: Accepta Reparatia La Universal 1010 DT");
         renderText(0.385, 0.32, 0.025, "       - Tasta N: Refuza Reparatia La Universal 1010 DT");
          renderText(0.385, 0.30, 0.025, "       - InGame Si Scripturi By Mihai94........");        
	end;

 if self.AvertizareCalareMotor then
     setTextBold(true);
  setTextColor(1,0,0,1);
  renderText(0.4, 0.9, 0.03, "(!) AI CALAT MOTORUL !");
  renderText(0.1, 0.8, 0.02, "AI CALAT MOTORUL DUTE LA REZERVORUL PENTRU APA SI ALIMENTEAZA APASAND TASTA 'B' MOTORUL CALAT (!)");
 end;
 
 if self.AvertizareGripareMotor then
     setTextBold(true);
  setTextColor(1,0,0,1);
  renderText(0.4, 0.9, 0.03, "(!) AI GRIPAT MOTORUL !");
  renderText(0.1, 0.8, 0.02, "AI GRIPAT MOTORUL DUTE LA REZERVORUL PENTRU ULEI SI ALIMENTEAZA APASAND TASTA 'R' MOTORUL GRIPAT (!)");
 end;
end;

function UTB1010DT:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
     return BaseMission.VEHICLE_LOAD_OK;
end;
function UTB1010DT:stopSounds()
	if self.isClient then
		 if self.fanSoundEnabled then
              stopSample(self.fanSound);
              self.fanSoundEnabled = false;
		 end;
	end;
	setVisibility(self.fanLed, false);
end;
function UTB1010DT:startMotor()
  -- if not self.isMotorStarted then
         -- self.isMotorStarted = true;
		self.fanSoundTime = self.time + 265500;
  -- end;
end;
function UTB1010DT:onEnter()
	if self.wipers.isActive then
		self:playAnimation(self.wipers.anim, self.wipers.speed, Utils.clamp(self:getAnimationTime(self.wipers.anim), 0, 1), true);	
	end;
end;
function getUserInRange(node, minDistance)
local result = false;
local px, py, pz = getWorldTranslation(node);
local Pl = 0;
for k,v in pairs(g_currentMission.players) do
  if g_currentMission.players[k].isControlled then
    Pl = g_currentMission.players[k].rootNode;
    break;
  end;
end;
if Pl ~= 0 then
  local vx, vy, vz = getWorldTranslation(Pl);
  local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
  if distance < minDistance then
  result = true;
  end;
end;
return result;
end;




