--
-- spc8
--
-- @autor Mihai94
--
--
spc8 = {};

function spc8.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(SowingMachine, specializations);
end;

function spc8:load(xmlFile)
	local MarcatorStangaNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.MarcatorStanga#index"));
    if MarcatorStangaNode ~= nil then
        self.MarcatorStanga = {};
        self.MarcatorStanga.node = MarcatorStangaNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.MarcatorStanga#minRot"));
        self.MarcatorStanga.minRot = {};
        self.MarcatorStanga.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.MarcatorStanga.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.MarcatorStanga.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.MarcatorStanga#maxRot"));
        self.MarcatorStanga.maxRot = {};
        self.MarcatorStanga.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.MarcatorStanga.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.MarcatorStanga.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.MarcatorStanga.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.MarcatorStanga#rotTime"), 200);
        self.MarcatorStanga.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.MarcatorStanga#touchRotLimit"), 10));
    end;



local MarcatorDreaptaNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.MarcatorDreapta#index"));
    if MarcatorDreaptaNode ~= nil then
        self.MarcatorDreapta = {};
        self.MarcatorDreapta.node = MarcatorDreaptaNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.MarcatorDreapta#minRot"));
        self.MarcatorDreapta.minRot = {};
        self.MarcatorDreapta.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.MarcatorDreapta.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.MarcatorDreapta.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.MarcatorDreapta#maxRot"));
        self.MarcatorDreapta.maxRot = {};
        self.MarcatorDreapta.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.MarcatorDreapta.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.MarcatorDreapta.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.MarcatorDreapta.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.MarcatorDreapta#rotTime"), 200);
        self.MarcatorDreapta.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.MarcatorDreapta#touchRotLimit"), 10));
    end;

self.cylinders = {};
	local i = 0;
	while true do
		local nameStr = string.format("vehicle.hydraulicCylinders.hydraulicCylinder(%d)", i);
        local cylinder = {};
        local cylinderStr = getXMLString(xmlFile, nameStr .. "#cylinder");
        if cylinderStr == nil then
            break;
        end;
        cylinder.index = Utils.indexToObject(self.components, cylinderStr);
        cylinder.directionFix = Utils.indexToObject(self.components, getXMLString(xmlFile, nameStr .. "#cylinderFix"));
		cylinder.punch = Utils.indexToObject(self.components, getXMLString(xmlFile, nameStr .. "#punch"));
		if cylinder.punch ~= nil then
			cylinder.translationFix = Utils.indexToObject(self.components, getXMLString(xmlFile, nameStr .. "#punchFix"));
			local ax, ay, az = getWorldTranslation(cylinder.punch);
			local bx, by, bz = getWorldTranslation(cylinder.translationFix);		
			cylinder.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		end;
		cylinder.scalePunch = Utils.getNoNil(getXMLBool(xmlFile, nameStr .. "#scale"), false);
		table.insert(self.cylinders, cylinder);
		i = i + 1;
	end;

end;
function spc8:delete()

end;

function spc8:mouseEvent(posX, posY, isDown, isUp, button)

end;

function spc8:keyEvent(unicode, sym, modifier, isDown)

end;

function spc8:update(dt)

if self.inrange or self.isEntered then

	if InputBinding.hasEvent (InputBinding.DeschideMarcatorStanga) then
		self.openMarcatorStanga = not self.openMarcatorStanga;
	end;

if InputBinding.hasEvent (InputBinding.DeschideMarcatorDreapta) then
		self.openMarcatorDreapta = not self.openMarcatorDreapta;
	end;

end;

	if self.inrange or self.isEntered then
		if self.openMarcatorStanga then
			g_currentMission:addExtraPrintText(string.format("Taste %s: Ridica Marcator Stanga", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideMarcatorStanga)));
		else
			g_currentMission:addExtraPrintText(string.format("Taste %s: Lasa Marcator Stanga", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideMarcatorStanga)));
		end;
	end; 

     if self.inrange or self.isEntered then
		if self.openMarcatorDreapta then
			g_currentMission:addExtraPrintText(string.format("Taste %s: Ridica Marcator Dreapta", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideMarcatorDreapta)));
		else
			g_currentMission:addExtraPrintText(string.format("Taste %s: Lasa Marcator Dreapta", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DeschideMarcatorDreapta)));
		end;
	end; 


	if self.MarcatorStanga ~= nil then
		local x, y, z = getRotation(self.MarcatorStanga.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.MarcatorStanga.minRot, self.MarcatorStanga.maxRot, 3, self.MarcatorStanga.rotTime, dt, self.openMarcatorStanga);
		setRotation(self.MarcatorStanga.node, unpack(newRot));
	end;

     if self.MarcatorDreapta ~= nil then
		local x, y, z = getRotation(self.MarcatorDreapta.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.MarcatorDreapta.minRot, self.MarcatorDreapta.maxRot, 3, self.MarcatorDreapta.rotTime, dt, self.openMarcatorDreapta);
		setRotation(self.MarcatorDreapta.node, unpack(newRot));
	end;

end;

function spc8:updateTick(dt)
if g_currentMission.player ~= nil then
		-- Getting the distance between the player and the implement 
		local nearestDistance = 4.0; --max distance allowed
		local px, py, pz = getWorldTranslation(self.rootNode); 
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance < nearestDistance then
			self.inrange = true; 
		else
			self.inrange = false; 
		end;
	end;

	for _, cylinder in pairs(self.cylinders) do
		local ax, ay, az = getWorldTranslation(cylinder.index);
		local bx, by, bz = getWorldTranslation(cylinder.directionFix);
		local x, y, z = worldDirectionToLocal(getParent(cylinder.index), bx-ax, by-ay, bz-az);
		local xU, yU, zU = 0, 1, 0;
		if math.abs(y) > 0.99 * Utils.vector3Length(x, y, z) then
			yU = 0;
			if y > 0 then
				zU = 1;
			else
				zU = -1;
			end;
		end;
		setDirection(cylinder.index, x, y, z, xU, yU, zU);
		if cylinder.punchDistance ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			if cylinder.scalePunch then
				local xS, yS, zS = getScale(cylinder.punch);
				local newS = xS * (distance / cylinder.punchDistance);
				setScale(cylinder.punch, xS, yS, newS);
			else
				setTranslation(cylinder.punch, 0, 0, distance-cylinder.punchDistance);
			end;
		end;
	end;
end;

function spc8:draw()  

end;

function spc8:onLeave()

end;